/*
 * Copyright 2021 Nilanjan Daw, Synerg Lab, Department of CSE, IIT Bombay
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package hpdos;

public class ConfigConstants {
    public static final String HOST = "localhost";
    public static final int PORT = 8080;
    public static final int HEARTBEAT_INTERVAL = 500;
    public static final int REPLICATION_TIMEOUT = 5000;
    public static final String replicationAsync = "async";
    // Backend types 300-399
    public static final int BACKEND_IN_MEMORY = 300;
    public static final int LSM_BACKEND = 301;
    public static final int BINARY_TREE_BACKEND = 302;
    public static final int REPLICATOR_THREAD_POOL_SIZE = Runtime.getRuntime().availableProcessors() * 2;
}
