/*
 * Copyright 2021 Nilanjan Daw, Synerg Lab, Department of CSE, IIT Bombay
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package hpdos.lib;

import java.time.Instant;


public class MasterFollower {
    private String ip;
    private int port;
    private final String followerID;
    private long lastSeen;

    public MasterFollower(String ip, int port, String followerID) {
        this.ip = ip;
        this.port = port;
        this.followerID = followerID;
        this.lastSeen = Instant.now().getEpochSecond();
    }

    public String getIp() {
        return ip;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    public int getPort() {
        return port;
    }

    public void setPort(int port) {
        this.port = port;
    }

    public String getFollowerID() {
        return followerID;
    }

    public long getLastSeen() {
        return lastSeen;
    }

    public void setLastSeen(long lastSeen) {
        this.lastSeen = lastSeen;
    }

    @Override
    public String toString() {
        return "MasterFollower {" +
                "ip='" + ip + '\'' +
                ", port=" + port +
                ", followerID='" + followerID + '\'' +
                '}';
    }
}
